#!/usr/bin/python
# -*- coding: utf-8 -*-
import urllib
import urllib2
import socket
import re
import sys
import xbmcplugin
import xbmcaddon
import xbmcgui
import HTMLParser
import subprocess
import json
import webbrowser
import datetime
import time
from pprint import pprint

socket.setdefaulttimeout(30)
pluginhandle = int(sys.argv[1])
addonId = 'plugin.video.skygosport'
addon = xbmcaddon.Addon(id=addonId)
translation = addon.getLocalizedString
baseUrl = "http://skygo.sky.de"
osWin = xbmc.getCondVisibility('system.platform.windows')
osOsx = xbmc.getCondVisibility('system.platform.osx')
osLinux = xbmc.getCondVisibility('system.platform.linux')
useCoverAsFanart = addon.getSetting("useCoverAsFanart") == "true"
forceViewMode = addon.getSetting("forceViewMode") == "true"
viewMode = str(addon.getSetting("viewMode"))
winBrowser = addon.getSetting("winBrowser")

def index():
	content = getUrl(baseUrl)
	content = content[content.find('<div class="container" id="primary_container">'):]
	content = content[:content.find('</nav>')]
	match = re.compile('<a href="(.+?)">(.+?)</a>', re.DOTALL).findall(content)
	for url, title in match:
		if title=="Sky Guide":
			fehler="Kein Sky Guide"
		else:
			addDir(title, url, 'getSecondaryNavigation', "")
	xbmcplugin.endOfDirectory(pluginhandle)

def getTertiaryNavigation(url):
	getNavigation(url, '<ul class="navlist tertiary">')
	
def getSecondaryNavigation(url):
	getNavigation(url)
	
def getNavigation(url, tertiary=""):
	actualurl=baseUrl+url
	pagename=url[url.rfind("/")+1:]
	jsonvalue=pagename[:pagename.find(".")]
	content = getUrl(actualurl)
	content = content[content.find('<div id="stage_nav_block" class="block">'):]
	content = content[content.find(tertiary+'<li landing_page_id="'+jsonvalue+'"'):]
	content = content[:content.find('</ul></nav>')]
	h = HTMLParser.HTMLParser()
	if len(content)==0:
		listOverviewPage(actualurl)
	else:			
		match = re.compile('<a href="(.+?)">(.+?)</a>', re.DOTALL).findall(content)
		for url, title in match:
			if title.startswith("<img title="):	
				title = title[title.find('"')+1:]
				title = title[:title.find('"')]
			if title == "Datencenter":
				fehler="Kein Datencenter"
			elif title == "Aktuell":
				fehler="Kein Aktuell"
			else:
				if tertiary=="":
					addDir(h.unescape(title), url, 'getTertiaryNavigation', "")	
				else:
					addDir(h.unescape(title), url, 'listOverviewPage', "")						
	xbmcplugin.endOfDirectory(pluginhandle)
		
def listOverviewPage(url):
	jsonurl=getJsonUrl(url)
	jsondata=getJsonData(jsonurl)
	structureType = jsondata['listing']['structureType']
	if structureType=="LandingPageSportNews":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageLiveplanner":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageSportClip":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageSportReplays":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageHighlights":
		for x in jsondata['listing']['listing']['item']:
			handleOnePageOrMultiplePages(x['path'],x['title'])
	elif structureType=="LandingPageSingleListing":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageOrderedListing":
		listByAToZ(jsondata['listing']['listing']['item'][0]['path'])
	elif structureType=="LandingPageHighlightsSNAP":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageSingleListingSNAP":
		handleListingListingItemPath(jsondata)
	elif structureType=="LandingPageOrderedListingSNAP":
		listByAToZ(jsondata['listing']['listing']['item'][0]['path'])	
	elif structureType=="LandingPageDoubleListing":
		for x in jsondata['listing']['listing']['item']:
			handleOnePageOrMultiplePages(x['path'],x['title'])		
		xbmcplugin.endOfDirectory(pluginhandle)
	else:
		xbmcgui.Dialog().ok("structureType", structureType, "","") 
			
def handleListingListingItemPath(jsondata):
	handleOnePageOrMultiplePages(jsondata['listing']['listing']['item']['path'])
	
def listSeries(series):	
	image=""
	try:
		image= baseUrl+series['main_picture']['picture'][0]['path']+"/"+series['main_picture']['picture'][0]['file']
	except IndexError:
			fehler= "kein Bild"
	addDir(series['title'].encode('utf-8'),series['webvod_canonical_url'], 'showSerie', image)
	
def handleListingAssetListingAsset(jsondata):
	try:
		d=jsondata['listing']['asset_listing']['asset']	
		try:
			for x in d:
				type=x['type']
				if type=="Series":
					try:
						x['episode_nr']
					except KeyError:
						listSeries(x)
				elif type=="Film":
					image=""
					try:
						image= baseUrl+x['main_picture']['picture'][0]['path']+"/"+x['main_picture']['picture'][0]['file']
					except IndexError:
						fehler= "kein Bild"

					addDir(x['title'].encode('utf-8'),x['webvod_canonical_url'], 'openBrowser', image)
				elif type=="Episode":
					#xbmcgui.Dialog().ok("structureType", "handlelala episode", "","") 
					image=""
					try:
						image= baseUrl+x['main_picture']['picture'][0]['path']+"/"+x['main_picture']['picture'][0]['file']
					except IndexError:
						fehler= "kein Bild"
		
					addDir(x['serie_title'].encode('utf-8')+": S"+str(x['season_nr'])+"E"+str(x['episode_nr']),x['webvod_canonical_url'], 'openBrowser', image)
		except KeyError:
			fehler= x['type'] +" fehler in handleListingAssetListingAsset"
	except KeyError:
		fehler= "data['listing']['asset_listing']['asset'] existiert nicht"		
				
def handleListingItems(jsondata):
	try:
		for x in jsondata['listing']['items']:
			try:
				handleOnePageOrMultiplePages(x['editorial_special']['path'])
			except KeyError:
				try:
					handleOnePageOrMultiplePages(x['automatic_listing']['path'])
				except KeyError:
					fehler= "exception"
	except KeyError:
		fehler= "kein jsondata['listing']['items']"

def handleListingListingAsset(jsondata):
	try:
		for x in jsondata['listing']['listing']['asset']:
			image=""
			try:
				image= baseUrl+x['main_picture']['picture'][0]['path']+"/"+x['main_picture']['picture'][0]['file']
			except IndexError:
				fehler= "kein Bild"
			startdate=x['technical_event']['on_air']['start_date'].encode('utf-8')
			s_date=startdate[8:]+"."+startdate[5:7]+"."+startdate[:4]
			s_time=x['technical_event']['on_air']['start_time']
#			xbmc.log('jetzt: %s' % time.strftime("%d.%m.%Y %H:%M"),xbmc.LOGNOTICE)								
#			xbmc.log('startdate: %s' % s_date+" "+s_time,xbmc.LOGNOTICE)
			live=""	
			nextdays=""
			
			if time.strftime("%Y")>=startdate[:4] and time.strftime("%m")>=startdate[5:7] and time.strftime("%d")>=startdate[8:]:
				if time.strftime("%H")>s_time[:2]:
					live="[COLOR red]LIVE[/COLOR] "
				elif  time.strftime("%H")==s_time[:2]:
					if time.strftime("%M")>=s_time[3:]:
						live="[COLOR red]LIVE[/COLOR] "
				
			if nextdays=="" and time.strftime("%Y")==startdate[:4] and time.strftime("%m")==startdate[5:7] and time.strftime("%d")==startdate[8:]:
				nextdays="[COLOR green]HEUTE[/COLOR] "

			if nextdays=="" and time.strftime("%Y")==startdate[:4] and time.strftime("%m")==startdate[5:7] and int(time.strftime("%d"))==int(startdate[8:])-1:
				nextdays="[COLOR blue]MORGEN[/COLOR] "


								#		xbmc.executebuiltin("Notification('sfd',datestring, 7000)")
			if live!="":
				title=live +x['title'].encode('utf-8')
				xbmc.log('live: %s' % s_date+" "+s_time,xbmc.LOGNOTICE)
			
			elif nextdays!="":
				xbmc.log('morgen oder heute: %s' % s_date+" "+s_time,xbmc.LOGNOTICE)
			
				title=nextdays+s_time.encode('utf-8')+" "+x['title'].encode('utf-8')
			else:
				title=s_date+" "+s_time.encode('utf-8')+" "+x['title'].encode('utf-8')
			addDir(title,x['webvod_canonical_url'], 'openBrowser', image)

	except KeyError:
		fehler= "kein data['listing']['listing']['asset']"
	
def handleOnePage(url):
	jsonurl=checkBaseUrl(url)
	data=getJsonData(jsonurl)
	handleListingItems(data)
	handleListingListingAsset(data)
	handleListingAssetListingAsset(data)
	xbmcplugin.endOfDirectory(pluginhandle)
	
def checkBaseUrl(url):
	if url.find("skygo.sky")>0:
		return url
	else:
		return baseUrl+url
	
def handleMultiplePages(jsonurl):
	pageid= int(jsonurl[jsonurl.rfind("_p")+2:jsonurl.rfind(".")])
	jsonurl=jsonurl[:jsonurl.rfind("_p")]
	jsonurl=checkBaseUrl(jsonurl)
	prefix='_p'
	extension='.json'
	
	if(pageid>1):
		prev=pageid-1
		prevurl=jsonurl+prefix+str(prev)+extension
		addDir("<< Vorherige Seite",prevurl, 'handleMultiplePages', '')
	data=getJsonData(jsonurl+prefix+str(pageid)+extension)
	handleListingListingItem(data)
	handleListingListingAsset(data)
	handleListingAssetListingAsset(data)
	next=pageid+1
	nexturl=jsonurl+prefix+str(next)+extension	
	try:
		getUrl(nexturl)
		addDir(">> Nächste Seite",nexturl, 'handleMultiplePages', '')

	except urllib2.HTTPError:
		fehler= "Keine nächste Seite"
	xbmcplugin.endOfDirectory(pluginhandle)
		
def handleListingListingItem(jsondata):
	try:
		d=jsondata['listing']['listing']['item']
		for x in d:
			string=""
			if len(x['item_subtitle'])>0:
				string=string+x['item_subtitle'].encode('utf-8')+": "
			string=string+x['item_title'].encode('utf-8')
			image=""
			try:
				image= baseUrl+x['main_picture']['picture'][0]['path']+"/"+x['main_picture']['picture'][0]['file']
			except KeyError:
				try:
					image= baseUrl+x['item_image']
				except IndexError:
					fehler= "kein Bild"			
			addDir(string,x['webvod_canonical_url'], 'openBrowser', image)
	except KeyError:
		fehler= "data['listing']['listing']['item'] existiert nicht"
		
def getJsonUrl(url):
	a=url[url.rfind("/")+1:]
	return "http://www.skygo.sky.de/sg/multiplatform/web/json/landingpage/"+a[:a.find(".")]+".json"	
	
def listByAToZ(jsonsuffix):
	jsonurl=checkBaseUrl(jsonsuffix)
	content = getUrl(jsonurl)	
	d=getJsonData(jsonurl)
	jsonurl=jsonurl[:jsonurl.rfind('/')+1]
	for x in d['letters']['letter']:
		if x['linkable'] == True:
			addDir(str(x['content']), jsonurl+str(x['content'])+"_p1.json", 'handleMultiplePages',"")
		else:
			addDir(str(x['content'])+" - keine Serie vorhanden", jsonsuffix, 'listByAToZ',"")
	xbmcplugin.endOfDirectory(pluginhandle)

def getJsonData(jsonurl):
	data = urllib.urlopen(jsonurl).read()
	d = json.loads(data)
	return d	
	
def showSerie(url):
	content = getUrl(url)
	searchstring =' + deliveryConf.json_basepath + "'
	content = content[content.find(searchstring)+len(searchstring):]
	content = content[:content.find('"')]
	jsonurl="http://www.skygo.sky.de/sg/multiplatform/"+content
	if jsonurl.find(".json")==-1:
		jsonurl=jsonurl+".json"
	d=getJsonData(jsonurl)
	if d['serieRecap']['serie']['seasons']['count']==0:
		jsonurl=jsonurl.replace("sg","snap")
		d=getJsonData(jsonurl)
	try:
		for x in d['serieRecap']['serie']['seasons']['season']:
			for y in x['episodes']['episode']:
				try:
					image=""
					try:
						image= baseUrl+y['main_picture']['picture'][0]['path']+"/"+y['main_picture']['picture'][0]['file']
					except IndexError:
						fehler= "kein Bild"		
					addDir(d['serieRecap']['serie']['title']+": "+"S"+str(x['nr'])+"E"+str(y['episode_nr'])+" "+y['title'], y['webvod_canonical_url'], 'openBrowser', image)
				except KeyError:
					fehler= "Fehler"
	except KeyError:
		fehler= "Fehler ShowSerie"
	xbmcplugin.endOfDirectory(pluginhandle)

def listPage(url):
	d=getJsonData(baseUrl+url)
	try:
		for x in d['listing']['listing']['asset']:
			try:
				addDir(x['title'], x['webvod_canonical_url'], 'openBrowser', '')
			except KeyError:
				fehler= "Fehler"
			try:
				addDir(x['serie_title'] + " S"+str(x['season_nr'])+"E"+str(x['episode_nr']), x['webvod_canonical_url'], 'openBrowser', '')
			except KeyError:
				fehler= "Fehler"	
	except KeyError:
		fehler=("Fehler")
	try:
		for x in d['listing']['asset_listing']['asset']:
			try:
				addDir(x['title'], x['webvod_canonical_url'], 'openBrowser', '')
			except KeyError:
				fehler= "Fehler"
			try:
				addDir(x['serie_title'] + " S"+str(x['season_nr'])+"E"+str(x['episode_nr']), x['webvod_canonical_url'], 'openBrowser', '')
			except KeyError:
				fehler= "Fehler"	
	except KeyError:
		fehler=("Fehler")							
	xbmcplugin.endOfDirectory(pluginhandle)

def openBrowser(url):
    xbmc.Player().stop()
    if osWin:
        if winBrowser=="0":
            xbmc.executebuiltin('RunPlugin(plugin://plugin.program.webbrowser/?url='+urllib.quote_plus(url)+'&mode=showSite&showScrollbar=yes)')
        elif winBrowser=="1":
            xbmc.executebuiltin('RunPlugin(plugin://plugin.program.chrome.launcher/?url='+urllib.quote_plus(url)+'&mode=showSite)')
        elif winBrowser=="2":
            webbrowser.open(url)
        elif winBrowser=="3":
            xbmc.executebuiltin('xbmc.PlayMedia('+url+')')
    elif osOsx or osLinux:
        xbmc.executebuiltin('RunPlugin(plugin://plugin.program.chrome.launcher/?url='+urllib.quote_plus(url)+'&mode=showSite)')
    else:
        xbmc.executebuiltin('XBMC.Notification(Info:, OS not supported!,5000)')

def getUrl(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; rv:19.0) Gecko/20100101 Firefox/19.0')
    response = urllib2.urlopen(req)
    link = response.read()
    response.close()
    return link

def parameters_string_to_dict(parameters):
    paramDict = {}
    if parameters:
        paramPairs = parameters[1:].split("&")
        for paramsPair in paramPairs:
            paramSplits = paramsPair.split('=')
            if (len(paramSplits)) == 2:
                paramDict[paramSplits[0]] = paramSplits[1]
    return paramDict

def addDir(name, url, mode, iconimage, desc=""):
	u = sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+urllib.quote_plus(mode)
	ok = True
	liz = xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setInfo(type="Video", infoLabels={"Title": name, "Plot": desc})
	if useCoverAsFanart:
		liz.setProperty("fanart_image", iconimage)
	ok = xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]), url=u, listitem=liz, isFolder=True)
	return ok
	
def handleOnePageOrMultiplePages(path,title=""):
	posUnderscore=path.rfind('_')
	posSlash=path.rfind('/')+1
	posPoint=path.rfind('.')
	try:
		int(path[posSlash:posPoint])
		if title=="":
			handleOnePage(path)
		else:
			addDir(title,path, "handleOnePage", '')
	except ValueError:
		if(posSlash<posUnderscore):
			try:
				int(path[posSlash:posUnderscore])
				handleMultiplePages(path)
			except ValueError:
				if title=="":
					handleOnePage(path)
				else:
					addDir(title,path, "handleOnePage", '')			
		else:
			handleOnePage(path)			
			
params = parameters_string_to_dict(sys.argv[2])
mode = urllib.unquote_plus(params.get('mode', ''))
url = urllib.unquote_plus(params.get('url', ''))

if mode == 'openBrowser':
    openBrowser(url)
elif mode == 'getSecondaryNavigation':
    getSecondaryNavigation(url)
elif mode == 'getTertiaryNavigation':
    getTertiaryNavigation(url)
elif mode=='showSerie':
	showSerie(url)
elif mode=='listOverviewPage':
	listOverviewPage(url)
elif mode=='handleMultiplePages':
	handleMultiplePages(url)
elif mode=='handleOnePage':
	handleOnePage(url)
else:
    index()
